import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class MachineEpsRandom extends Frame
{
  private int RandomIndex;
  private double [] RandomTable=new double[56];
  public MachineEpsRandom()
   {  setSize(1100,700);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private double MachineEP()
   {  double E = 1; double ED = E;
      while ((E+1) != 1) { ED = E; E /= 2;}
      E = 1 + ED; return (E - 1);
   }
   private void randomTableSet()
   { int i; double R;
     for(i=1; i<25; i++)
     { R = RandomTable[i] - RandomTable[i + 31];
       RandomTable[i] = R; if(R < 0) RandomTable[i] = R + 1;
     }
     for(i = 25; i< 56; i++)
     {  R = RandomTable[i] - RandomTable[i - 24];
        RandomTable[i] = R; if(R < 0) RandomTable[i] = R + 1;
     }
  }
  public void initRandom2()
  { int i, j; double R;
    double Seed = Math.random();  RandomTable[55] = Seed;
    R = MachineEP();
    for(i = 1; i<55; i++)
    { j = (21 * i) % 55;
      RandomTable[j] = R;
      R = Seed - R; if( R < 0) R ++;
      Seed = RandomTable[j];
    }
    randomTableSet();
    randomTableSet();
    randomTableSet();
    RandomIndex = 55;
  }
  public double Random2()
  {
     RandomIndex ++;
     if(RandomIndex > 55)
     { randomTableSet();
       RandomIndex = 1;
     }
     return RandomTable[RandomIndex];
  }
  public void paint(Graphics g)
  { setTitle("	@BGvVɂ闐");
    initRandom2();
    for(int i=1; i<=20; i++)  g.drawString("@ "+ Random2(), 100,100+i*14);
  } 
  public static void main(String[] args)
  {  Frame w = new MachineEpsRandom();
     w.setVisible(true);
  }
}
